import java.util.*;
public class OrderedGuesser {
    public static void main(String[] args){
        boolean[] passwordGuess = {false,true,true,false};
        double[] confidenceRatings = {0.95, 0.76, 0.62, 0.92};
        generateGuesses(passwordGuess, confidenceRatings);
    }

    private static void printPassword(boolean[] arr){
        for(int i=0; i<arr.length; i++){
            System.out.print(arr[i]? '1':'0');
        }
        System.out.println("");
    }

    // We want to generate every possible guess, but in most-likely to least-likely order!
    public static void generateGuesses(boolean[] password, double[] confidenceRatings){
        List<Integer> sortedIndicies = getSortedIndicies(confidenceRatings);
        generateGuesses(password, sortedIndicies, 0);
    }

    private static void generateGuesses(boolean[] currPassword, List<Integer> guessOrder, int currGuessIndex){
        /* Your code here! */
    }

    
    // A useful helper, generates an ordered list of indicies from least confident to most
    private static List<Integer> getSortedIndicies(double[] arr){
        TreeMap<Double,Integer> tMap = new TreeMap<Double,Integer>(Collections.reverseOrder());
        for(int i=0; i<arr.length; i++){
            tMap.put(arr[i], i);
        }
        List<Integer> indicies = new ArrayList<>();
        for( Integer v : tMap.values()){
            indicies.add(v);
        }
        return new ArrayList<Integer>(tMap.values());
    }
    
}
